#include<stdio.h>
#include<stdlib.h>
#include<math.h>


#define Number 151


long double LogFact(int x){
	if(x<2)	return 0;
	else	return ( log10(x) + LogFact(x-1) ) ;
}

//log_fisher:probability density
double logfisher(int a, int b , int c, int d){
	double deno,nume;
	deno = LogFact(a+b) + LogFact(c+d) + LogFact(a+c) + LogFact(b+d);
	nume = LogFact(a+b+c+d) + LogFact(a) + LogFact(b) + LogFact(c) + LogFact(d);
	return ( deno - nume );
}

//log_fisher : double-tailed
double fisher(int a , int b , int c , int d){
	int ab = a + b;
	int ac = a + c;
	int num = a + b + c + d;
	int array = ( ab  > ac)? ac : ab;
	double p = 0.0;
	int a2,b2,c2,d2;
	double s,s2;
	s = a*d -b*c;
	
	for( a2 = 0 ; a2 <= array ; a2++){
		b2 = ab - a2;
		c2 = ac - a2;
		d2 = num - a2 - b2 - c2;
		s2 = a2*d2 - b2*c2;
		
		if( a2 >= 0 && b2 >= 0 && c2>= 0 && d2 >= 0){
			if( fabs(s) <= fabs(s2) ){
				p += pow( 10 , logfisher(a2,b2,c2,d2)   );
			}
		}
	}
	return p;
}


int double_comp(const void *_a, const void *_b) {	//for qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}

double med( double *x){
	int i;
	double *tmp;
	tmp = (double *) calloc( Number, sizeof(double) );
	for(i=0;i<Number;i++)	tmp[i] = x[i];
	
	qsort(tmp , Number , sizeof(double) , double_comp);
	
	
	if(Number % 2 == 0){
		return (tmp[Number/2-1] + tmp[Number/2+1])/2.0;
	}
	else{
		return (tmp[Number/2]);
	}
	free(tmp);
}




int main(){
	int i ,ret ,tmp1;
	double tmp2;
	FILE *fpr,*fpw;
	fpr = fopen("time.dat", "r");
	fpw = fopen("P.dat", "w");

	double *time;
	time = (double *)calloc( Number , sizeof(double) );
	
	while( (ret=fscanf(fpr,"%d	%lf",&tmp1,&tmp2)) != EOF){
		time[tmp1] = tmp2;
	}
	int a,b,c,d;
	int ith;
	double xth;
	xth = med(time);	//median
	
	
	for(i=0;i<Number;i++){
		a = b = c = d = 0;
		ith = i;
		
		for(ret = 0 ; ret<Number ; ret++){
			if( time[ret] > xth && ret < ith)	a++;
			if( time[ret] > xth && ret >= ith)	b++;
			if( time[ret] <= xth && ret < ith)	c++;
			if( time[ret] <= xth && ret >= ith)	d++;
		}
		
		fprintf(fpw,"%d	%.20f\n",i,log10(fisher(a,b,c,d)));
		
		
	}
	
	fclose(fpr);
	fclose(fpw);
	free(time);
	return 0;
}

